diff -uNr openmp-3.5.0.src/runtime/src/kmp_runtime.c openmp-3.5.0.src.r219214/runtime/src/kmp_runtime.c
--- openmp-3.5.0.src/runtime/src/kmp_runtime.c	2014-08-07 07:16:59.000000000 -0400
+++ openmp-3.5.0.src.r219214/runtime/src/kmp_runtime.c	2014-10-24 19:58:41.000000000 -0400
@@ -3380,20 +2366,20 @@
         if ( kind == kmp_sched_static && chunk < KMP_DEFAULT_CHUNK ) {
             // differ static chunked vs. unchunked:
             // chunk should be invalid to indicate unchunked schedule (which is the default)
-            thread -> th.th_current_task -> td_icvs.sched.r_sched_type = kmp_sch_static;
+            thread->th.th_current_task->td_icvs.sched.r_sched_type = kmp_sch_static;
         } else {
-            thread -> th.th_current_task -> td_icvs.sched.r_sched_type = __kmp_sch_map[ kind - kmp_sched_lower - 1 ];
+            thread->th.th_current_task->td_icvs.sched.r_sched_type = __kmp_sch_map[ kind - kmp_sched_lower - 1 ];
         }
     } else {
         //    __kmp_sch_map[ kind - kmp_sched_lower_ext + kmp_sched_upper_std - kmp_sched_lower - 2 ];
-        thread -> th.th_current_task -> td_icvs.sched.r_sched_type =
+        thread->th.th_current_task->td_icvs.sched.r_sched_type =
             __kmp_sch_map[ kind - kmp_sched_lower_ext + kmp_sched_upper_std - kmp_sched_lower - 2 ];
     }
     if ( kind == kmp_sched_auto ) {
         // ignore parameter chunk for schedule auto
-        thread -> th.th_current_task -> td_icvs.sched.chunk = KMP_DEFAULT_CHUNK;
+        thread->th.th_current_task->td_icvs.sched.chunk = KMP_DEFAULT_CHUNK;
     } else {
-        thread -> th.th_current_task -> td_icvs.sched.chunk = chunk;
+        thread->th.th_current_task->td_icvs.sched.chunk = chunk;
     }
 }
 
@@ -3410,8 +2396,8 @@
 
     thread = __kmp_threads[ gtid ];
 
-    //th_type = thread -> th.th_team -> t.t_set_sched[ thread->th.th_info.ds.ds_tid ].r_sched_type;
-    th_type = thread -> th.th_current_task -> td_icvs.sched.r_sched_type;
+    //th_type = thread->th.th_team->t.t_set_sched[ thread->th.th_info.ds.ds_tid ].r_sched_type;
+    th_type = thread->th.th_current_task->td_icvs.sched.r_sched_type;
 
     switch ( th_type ) {
     case kmp_sch_static:
@@ -3446,8 +2432,8 @@
         KMP_FATAL( UnknownSchedulingType, th_type );
     }
 
-    //*chunk = thread -> th.th_team -> t.t_set_sched[ thread->th.th_info.ds.ds_tid ].chunk;
-    *chunk = thread -> th.th_current_task -> td_icvs.sched.chunk;
+    //*chunk = thread->th.th_team->t.t_set_sched[ thread->th.th_info.ds.ds_tid ].chunk;
+    *chunk = thread->th.th_current_task->td_icvs.sched.chunk;
 }
 
 int
@@ -3465,11 +2451,11 @@
     if( level < 0 ) return -1;
     thr = __kmp_threads[ gtid ];
     team = thr->th.th_team;
-    ii = team -> t.t_level;
+    ii = team->t.t_level;
     if( level > ii ) return -1;
 
 #if OMP_40_ENABLED
-    if( thr->th.th_team_microtask ) {
+    if( thr->th.th_teams_microtask ) {
         // AC: we are in teams region where multiple nested teams have same level
         int tlevel = thr->th.th_teams_level; // the level of the teams construct
         if( level <= tlevel ) { // otherwise usual algorithm works (will not touch the teams)
@@ -3486,25 +2472,25 @@
 
     if( ii == level ) return __kmp_tid_from_gtid( gtid );
 
-    dd = team -> t.t_serialized;
+    dd = team->t.t_serialized;
     level++;
     while( ii > level )
     {
-        for( dd = team -> t.t_serialized; ( dd > 0 ) && ( ii > level ); dd--, ii-- )
+        for( dd = team->t.t_serialized; ( dd > 0 ) && ( ii > level ); dd--, ii-- )
         {
         }
-        if( ( team -> t.t_serialized ) && ( !dd ) ) {
+        if( ( team->t.t_serialized ) && ( !dd ) ) {
             team = team->t.t_parent;
             continue;
         }
         if( ii > level ) {
             team = team->t.t_parent;
-            dd = team -> t.t_serialized;
+            dd = team->t.t_serialized;
             ii--;
         }
     }
 
-    return ( dd > 1 ) ? ( 0 ) : ( team -> t.t_master_tid );
+    return ( dd > 1 ) ? ( 0 ) : ( team->t.t_master_tid );
 }
 
 int
@@ -3522,11 +2508,11 @@
     if( level < 0 ) return -1;
     thr = __kmp_threads[ gtid ];
     team = thr->th.th_team;
-    ii = team -> t.t_level;
+    ii = team->t.t_level;
     if( level > ii ) return -1;
 
 #if OMP_40_ENABLED
-    if( thr->th.th_team_microtask ) {
+    if( thr->th.th_teams_microtask ) {
         // AC: we are in teams region where multiple nested teams have same level
         int tlevel = thr->th.th_teams_level; // the level of the teams construct
         if( level <= tlevel ) { // otherwise usual algorithm works (will not touch the teams)
@@ -3543,10 +2529,10 @@
 
     while( ii > level )
     {
-        for( dd = team -> t.t_serialized; ( dd > 0 ) && ( ii > level ); dd--, ii-- )
+        for( dd = team->t.t_serialized; ( dd > 0 ) && ( ii > level ); dd--, ii-- )
         {
         }
-        if( team -> t.t_serialized && ( !dd ) ) {
+        if( team->t.t_serialized && ( !dd ) ) {
             team = team->t.t_parent;
             continue;
         }
@@ -3556,11 +2542,9 @@
         }
     }
 
-    return team -> t.t_nproc;
+    return team->t.t_nproc;
 }
 
-#endif // OMP_30_ENABLED
-
 kmp_r_sched_t
 __kmp_get_schedule_global() {
 // This routine created because pairs (__kmp_sched, __kmp_chunk) and (__kmp_static, __kmp_guided)
@@ -3601,21 +2585,20 @@
 {
 
     KMP_DEBUG_ASSERT( team );
-    if( !realloc || argc > team -> t.t_max_argc ) {
+    if( !realloc || argc > team->t.t_max_argc ) {
 
         KA_TRACE( 100, ( "__kmp_alloc_argv_entries: team %d: needed entries=%d, current entries=%d\n",
                          team->t.t_id, argc, ( realloc ) ? team->t.t_max_argc : 0 ));
-#if (KMP_PERF_V106 == KMP_ON)
         /* if previously allocated heap space for args, free them */
-        if ( realloc && team -> t.t_argv != &team -> t.t_inline_argv[0] )
-            __kmp_free( (void *) team -> t.t_argv );
+        if ( realloc && team->t.t_argv != &team->t.t_inline_argv[0] )
+            __kmp_free( (void *) team->t.t_argv );
 
         if ( argc <= KMP_INLINE_ARGV_ENTRIES ) {
             /* use unused space in the cache line for arguments */
-            team -> t.t_max_argc = KMP_INLINE_ARGV_ENTRIES;
+            team->t.t_max_argc = KMP_INLINE_ARGV_ENTRIES;
             KA_TRACE( 100, ( "__kmp_alloc_argv_entries: team %d: inline allocate %d argv entries\n",
                              team->t.t_id, team->t.t_max_argc ));
-            team -> t.t_argv = &team -> t.t_inline_argv[0];
+            team->t.t_argv = &team->t.t_inline_argv[0];
             if ( __kmp_storage_map ) {
                 __kmp_print_storage_map_gtid( -1, &team->t.t_inline_argv[0],
                                          &team->t.t_inline_argv[KMP_INLINE_ARGV_ENTRIES],
@@ -3625,31 +2608,17 @@
             }
         } else {
             /* allocate space for arguments in the heap */
-            team -> t.t_max_argc = ( argc <= (KMP_MIN_MALLOC_ARGV_ENTRIES >> 1 )) ?
+            team->t.t_max_argc = ( argc <= (KMP_MIN_MALLOC_ARGV_ENTRIES >> 1 )) ?
                                      KMP_MIN_MALLOC_ARGV_ENTRIES : 2 * argc;
             KA_TRACE( 100, ( "__kmp_alloc_argv_entries: team %d: dynamic allocate %d argv entries\n",
                              team->t.t_id, team->t.t_max_argc ));
-            team -> t.t_argv     = (void**) __kmp_page_allocate( sizeof(void*) * team->t.t_max_argc );
+            team->t.t_argv     = (void**) __kmp_page_allocate( sizeof(void*) * team->t.t_max_argc );
             if ( __kmp_storage_map ) {
                 __kmp_print_storage_map_gtid( -1, &team->t.t_argv[0], &team->t.t_argv[team->t.t_max_argc],
                                          sizeof(void *) * team->t.t_max_argc, "team_%d.t_argv",
                                          team->t.t_id );
             }
         }
-#else /* KMP_PERF_V106 == KMP_OFF */
-        if ( realloc )
-            __kmp_free( (void*) team -> t.t_argv );
-        team -> t.t_max_argc = ( argc <= (KMP_MIN_MALLOC_ARGV_ENTRIES >> 1 )) ?
-                             KMP_MIN_MALLOC_ARGV_ENTRIES : 2 * argc;
-        KA_TRACE( 100, ( "__kmp_alloc_argv_entries: team %d: dynamic allocate %d argv entries\n",
-                         team->t.t_id, team->t.t_max_argc ));
-        team -> t.t_argv     = __kmp_page_allocate( sizeof(void*) * team->t.t_max_argc );
-        if ( __kmp_storage_map ) {
-            __kmp_print_storage_map_gtid( -1, &team->t.t_argv[0], &team->t.t_argv[team->t.t_max_argc],
-                                     sizeof(void *) * team->t.t_max_argc, "team_%d.t_argv", team->t.t_id );
-        }
-#endif /* KMP_PERF_V106 */
-
     }
 }
 
@@ -3663,55 +2632,41 @@
     char *ptr = __kmp_allocate(max_nth *
                             ( sizeof(kmp_info_t*) + sizeof(dispatch_shared_info_t)*num_disp_buf
                                + sizeof(kmp_disp_t) + sizeof(int)*6
-#  if OMP_30_ENABLED
                                //+ sizeof(int)
                                + sizeof(kmp_r_sched_t)
-                               + sizeof(kmp_taskdata_t)
-#  endif // OMP_30_ENABLED
-                        )     );
+                               + sizeof(kmp_taskdata_t) ) );
 
-    team -> t.t_threads          = (kmp_info_t**) ptr; ptr += sizeof(kmp_info_t*) * max_nth;
-    team -> t.t_disp_buffer      = (dispatch_shared_info_t*) ptr;
+    team->t.t_threads          = (kmp_info_t**) ptr; ptr += sizeof(kmp_info_t*) * max_nth;
+    team->t.t_disp_buffer      = (dispatch_shared_info_t*) ptr;
                                    ptr += sizeof(dispatch_shared_info_t) * num_disp_buff;
-    team -> t.t_dispatch         = (kmp_disp_t*) ptr; ptr += sizeof(kmp_disp_t) * max_nth;
-    team -> t.t_set_nproc        = (int*) ptr; ptr += sizeof(int) * max_nth;
-    team -> t.t_set_dynamic      = (int*) ptr; ptr += sizeof(int) * max_nth;
-    team -> t.t_set_nested       = (int*) ptr; ptr += sizeof(int) * max_nth;
-    team -> t.t_set_blocktime    = (int*) ptr; ptr += sizeof(int) * max_nth;
-    team -> t.t_set_bt_intervals = (int*) ptr; ptr += sizeof(int) * max_nth;
-    team -> t.t_set_bt_set       = (int*) ptr;
-#  if OMP_30_ENABLED
+    team->t.t_dispatch         = (kmp_disp_t*) ptr; ptr += sizeof(kmp_disp_t) * max_nth;
+    team->t.t_set_nproc        = (int*) ptr; ptr += sizeof(int) * max_nth;
+    team->t.t_set_dynamic      = (int*) ptr; ptr += sizeof(int) * max_nth;
+    team->t.t_set_nested       = (int*) ptr; ptr += sizeof(int) * max_nth;
+    team->t.t_set_blocktime    = (int*) ptr; ptr += sizeof(int) * max_nth;
+    team->t.t_set_bt_intervals = (int*) ptr; ptr += sizeof(int) * max_nth;
+    team->t.t_set_bt_set       = (int*) ptr;
     ptr += sizeof(int) * max_nth;
-    //team -> t.t_set_max_active_levels = (int*) ptr; ptr += sizeof(int) * max_nth;
-    team -> t.t_set_sched        = (kmp_r_sched_t*) ptr;
+    //team->t.t_set_max_active_levels = (int*) ptr; ptr += sizeof(int) * max_nth;
+    team->t.t_set_sched        = (kmp_r_sched_t*) ptr;
     ptr += sizeof(kmp_r_sched_t) * max_nth;
-    team -> t.t_implicit_task_taskdata = (kmp_taskdata_t*) ptr;
+    team->t.t_implicit_task_taskdata = (kmp_taskdata_t*) ptr;
     ptr += sizeof(kmp_taskdata_t) * max_nth;
-#  endif // OMP_30_ENABLED
 #else
 
-    team -> t.t_threads = (kmp_info_t**) __kmp_allocate( sizeof(kmp_info_t*) * max_nth );
-    team -> t.t_disp_buffer = (dispatch_shared_info_t*)
+    team->t.t_threads = (kmp_info_t**) __kmp_allocate( sizeof(kmp_info_t*) * max_nth );
+    team->t.t_disp_buffer = (dispatch_shared_info_t*)
         __kmp_allocate( sizeof(dispatch_shared_info_t) * num_disp_buff );
-    team -> t.t_dispatch = (kmp_disp_t*) __kmp_allocate( sizeof(kmp_disp_t) * max_nth );
-    #if OMP_30_ENABLED
-    //team -> t.t_set_max_active_levels = (int*) __kmp_allocate( sizeof(int) * max_nth );
-    //team -> t.t_set_sched = (kmp_r_sched_t*) __kmp_allocate( sizeof(kmp_r_sched_t) * max_nth );
-    team -> t.t_implicit_task_taskdata = (kmp_taskdata_t*) __kmp_allocate( sizeof(kmp_taskdata_t) * max_nth );
-    #else
-    team -> t.t_set_nproc = (int*) __kmp_allocate( sizeof(int) * max_nth );
-    team -> t.t_set_dynamic = (int*) __kmp_allocate( sizeof(int) * max_nth );
-    team -> t.t_set_nested = (int*) __kmp_allocate( sizeof(int) * max_nth );
-    team -> t.t_set_blocktime = (int*) __kmp_allocate( sizeof(int) * max_nth );
-    team -> t.t_set_bt_intervals = (int*) __kmp_allocate( sizeof(int) * max_nth );
-    team -> t.t_set_bt_set = (int*) __kmp_allocate( sizeof(int) * max_nth );
-#  endif // OMP_30_ENABLED
+    team->t.t_dispatch = (kmp_disp_t*) __kmp_allocate( sizeof(kmp_disp_t) * max_nth );
+    //team->t.t_set_max_active_levels = (int*) __kmp_allocate( sizeof(int) * max_nth );
+    //team->t.t_set_sched = (kmp_r_sched_t*) __kmp_allocate( sizeof(kmp_r_sched_t) * max_nth );
+    team->t.t_implicit_task_taskdata = (kmp_taskdata_t*) __kmp_allocate( sizeof(kmp_taskdata_t) * max_nth );
 #endif
     team->t.t_max_nproc = max_nth;
 
     /* setup dispatch buffers */
     for(i = 0 ; i < num_disp_buff; ++i)
-        team -> t.t_disp_buffer[i].buffer_index = i;
+        team->t.t_disp_buffer[i].buffer_index = i;
 }
 
 static void
@@ -3728,34 +2683,16 @@
     #if !KMP_USE_POOLED_ALLOC
         __kmp_free(team->t.t_disp_buffer);
         __kmp_free(team->t.t_dispatch);
-        #if OMP_30_ENABLED
         //__kmp_free(team->t.t_set_max_active_levels);
         //__kmp_free(team->t.t_set_sched);
         __kmp_free(team->t.t_implicit_task_taskdata);
-        #else
-        __kmp_free(team->t.t_set_nproc);
-        __kmp_free(team->t.t_set_dynamic);
-        __kmp_free(team->t.t_set_nested);
-        __kmp_free(team->t.t_set_blocktime);
-        __kmp_free(team->t.t_set_bt_intervals);
-        __kmp_free(team->t.t_set_bt_set);
-    #  endif // OMP_30_ENABLED
     #endif
     team->t.t_threads     = NULL;
     team->t.t_disp_buffer = NULL;
     team->t.t_dispatch    = NULL;
-#if OMP_30_ENABLED
     //team->t.t_set_sched   = 0;
     //team->t.t_set_max_active_levels = 0;
     team->t.t_implicit_task_taskdata = 0;
-#else
-    team->t.t_set_nproc   = 0;
-    team->t.t_set_dynamic = 0;
-    team->t.t_set_nested  = 0;
-    team->t.t_set_blocktime   = 0;
-    team->t.t_set_bt_intervals = 0;
-    team->t.t_set_bt_set  = 0;
-#endif // OMP_30_ENABLED
 }
 
 static void
@@ -3765,18 +2702,9 @@
     #if !KMP_USE_POOLED_ALLOC
         __kmp_free(team->t.t_disp_buffer);
         __kmp_free(team->t.t_dispatch);
-        #if OMP_30_ENABLED
         //__kmp_free(team->t.t_set_max_active_levels);
         //__kmp_free(team->t.t_set_sched);
         __kmp_free(team->t.t_implicit_task_taskdata);
-        #else
-        __kmp_free(team->t.t_set_nproc);
-        __kmp_free(team->t.t_set_dynamic);
-        __kmp_free(team->t.t_set_nested);
-        __kmp_free(team->t.t_set_blocktime);
-        __kmp_free(team->t.t_set_bt_intervals);
-        __kmp_free(team->t.t_set_bt_set);
-    #  endif // OMP_30_ENABLED
     #endif
     __kmp_allocate_team_arrays(team, max_nth);
 
@@ -3788,9 +2716,7 @@
 static kmp_internal_control_t
 __kmp_get_global_icvs( void ) {
 
-#if OMP_30_ENABLED
     kmp_r_sched_t r_sched = __kmp_get_schedule_global(); // get current state of scheduling globals
-#endif /* OMP_30_ENABLED */
 
 #if OMP_40_ENABLED
     KMP_DEBUG_ASSERT( __kmp_nested_proc_bind.used > 0 );
@@ -3798,18 +2724,15 @@
 
     kmp_internal_control_t g_icvs = {
       0,                            //int serial_nesting_level; //corresponds to the value of the th_team_serialized field
-      __kmp_dflt_nested,            //int nested;               //internal control for nested parallelism (per thread)
-      __kmp_global.g.g_dynamic,                                 //internal control for dynamic adjustment of threads (per thread)
-      __kmp_dflt_team_nth,
-                                    //int nproc;                //internal control for # of threads for next parallel region (per thread)
-                                    // (use a max ub on value if __kmp_parallel_initialize not called yet)
+      (kmp_int8)__kmp_dflt_nested,            //int nested;               //internal control for nested parallelism (per thread)
+      (kmp_int8)__kmp_global.g.g_dynamic,                                 //internal control for dynamic adjustment of threads (per thread)
+      (kmp_int8)__kmp_env_blocktime,          //int bt_set;               //internal control for whether blocktime is explicitly set
       __kmp_dflt_blocktime,         //int blocktime;            //internal control for blocktime
       __kmp_bt_intervals,           //int bt_intervals;         //internal control for blocktime intervals
-      __kmp_env_blocktime,          //int bt_set;               //internal control for whether blocktime is explicitly set
-#if OMP_30_ENABLED
+      __kmp_dflt_team_nth,          //int nproc;                //internal control for # of threads for next parallel region (per thread)
+                                    // (use a max ub on value if __kmp_parallel_initialize not called yet)
       __kmp_dflt_max_active_levels, //int max_active_levels;    //internal control for max_active_levels
       r_sched,                      //kmp_r_sched_t sched;      //internal control for runtime schedule {sched,chunk} pair
-#endif /* OMP_30_ENABLED */
 #if OMP_40_ENABLED
       __kmp_nested_proc_bind.bind_types[0],
 #endif /* OMP_40_ENABLED */
@@ -3822,24 +2745,10 @@
 static kmp_internal_control_t
 __kmp_get_x_global_icvs( const kmp_team_t *team ) {
 
-    #if OMP_30_ENABLED
     kmp_internal_control_t gx_icvs;
     gx_icvs.serial_nesting_level = 0; // probably =team->t.t_serial like in save_inter_controls
     copy_icvs( & gx_icvs, & team->t.t_threads[0]->th.th_current_task->td_icvs );
     gx_icvs.next = NULL;
-    #else
-    kmp_internal_control_t gx_icvs =
-    {
-      0,
-      team->t.t_set_nested[0],
-      team->t.t_set_dynamic[0],
-      team->t.t_set_nproc[0],
-      team->t.t_set_blocktime[0],
-      team->t.t_set_bt_intervals[0],
-      team->t.t_set_bt_set[0],
-      NULL                          //struct kmp_internal_control *next;
-    };
-    #endif // OMP_30_ENABLED
 
     return gx_icvs;
 }
@@ -3852,20 +2761,18 @@
     kmp_team_t   *hot_team;
     size_t        disp_size, dispatch_size, bar_size;
     int           hot_team_max_nth;
-#if OMP_30_ENABLED
     kmp_r_sched_t r_sched = __kmp_get_schedule_global(); // get current state of scheduling globals
     kmp_internal_control_t r_icvs = __kmp_get_global_icvs();
-#endif // OMP_30_ENABLED
     KMP_DEBUG_ASSERT( root );
     KMP_ASSERT( ! root->r.r_begin );
 
     /* setup the root state structure */
     __kmp_init_lock( &root->r.r_begin_lock );
-    root -> r.r_begin        = FALSE;
-    root -> r.r_active       = FALSE;
-    root -> r.r_in_parallel  = 0;
-    root -> r.r_blocktime    = __kmp_dflt_blocktime;
-    root -> r.r_nested       = __kmp_dflt_nested;
+    root->r.r_begin        = FALSE;
+    root->r.r_active       = FALSE;
+    root->r.r_in_parallel  = 0;
+    root->r.r_blocktime    = __kmp_dflt_blocktime;
+    root->r.r_nested       = __kmp_dflt_nested;
 
     /* setup the root team for this task */
     /* allocate the root team structure */
@@ -3878,33 +2785,23 @@
 #if OMP_40_ENABLED
             __kmp_nested_proc_bind.bind_types[0],
 #endif
-#if OMP_30_ENABLED
             &r_icvs,
-#else
-            __kmp_dflt_team_nth_ub,                                    // num_treads
-            __kmp_global.g.g_dynamic,                                  // dynamic
-            __kmp_dflt_nested,                                         // nested
-            __kmp_dflt_blocktime,                                      // blocktime
-            __kmp_bt_intervals,                                        // bt_intervals
-            __kmp_env_blocktime,                                       // bt_set
-#endif // OMP_30_ENABLED
             0                                                          // argc
+            USE_NESTED_HOT_ARG(NULL)                                   // master thread is unknown
         );
 
     KF_TRACE( 10, ( "__kmp_initialize_root: after root_team = %p\n", root_team ) );
 
-    root -> r.r_root_team = root_team;
-    root_team -> t.t_control_stack_top = NULL;
+    root->r.r_root_team = root_team;
+    root_team->t.t_control_stack_top = NULL;
 
     /* initialize root team */
-    root_team -> t.t_threads[0] = NULL;
-    root_team -> t.t_nproc      = 1;
-    root_team -> t.t_serialized = 1;
-#if OMP_30_ENABLED
-    // TODO???: root_team -> t.t_max_active_levels = __kmp_dflt_max_active_levels;
-    root_team -> t.t_sched.r_sched_type = r_sched.r_sched_type;
-    root_team -> t.t_sched.chunk        = r_sched.chunk;
-#endif // OMP_30_ENABLED
+    root_team->t.t_threads[0] = NULL;
+    root_team->t.t_nproc      = 1;
+    root_team->t.t_serialized = 1;
+    // TODO???: root_team->t.t_max_active_levels = __kmp_dflt_max_active_levels;
+    root_team->t.t_sched.r_sched_type = r_sched.r_sched_type;
+    root_team->t.t_sched.chunk        = r_sched.chunk;
     KA_TRACE( 20, ("__kmp_initialize_root: init root team %d arrived: join=%u, plain=%u\n",
                     root_team->t.t_id, KMP_INIT_BARRIER_STATE, KMP_INIT_BARRIER_STATE ));
 
@@ -3919,39 +2816,29 @@
 #if OMP_40_ENABLED
             __kmp_nested_proc_bind.bind_types[0],
 #endif
-#if OMP_30_ENABLED
             &r_icvs,
-#else
-            __kmp_dflt_team_nth_ub,                                    // num_treads
-            __kmp_global.g.g_dynamic,                                  // dynamic
-            __kmp_dflt_nested,                                         // nested
-            __kmp_dflt_blocktime,                                      // blocktime
-            __kmp_bt_intervals,                                        // bt_intervals
-            __kmp_env_blocktime,                                       // bt_set
-#endif // OMP_30_ENABLED
             0                                                          // argc
+            USE_NESTED_HOT_ARG(NULL)                                   // master thread is unknown
         );
     KF_TRACE( 10, ( "__kmp_initialize_root: after hot_team = %p\n", hot_team ) );
 
-    root -> r.r_hot_team = hot_team;
-    root_team -> t.t_control_stack_top = NULL;
+    root->r.r_hot_team = hot_team;
+    root_team->t.t_control_stack_top = NULL;
 
     /* first-time initialization */
-    hot_team -> t.t_parent = root_team;
+    hot_team->t.t_parent = root_team;
 
     /* initialize hot team */
     hot_team_max_nth = hot_team->t.t_max_nproc;
     for ( f = 0; f < hot_team_max_nth; ++ f ) {
-        hot_team -> t.t_threads[ f ] = NULL;
+        hot_team->t.t_threads[ f ] = NULL;
     }; // for
-    hot_team -> t.t_nproc = 1;
-#if OMP_30_ENABLED
-    // TODO???: hot_team -> t.t_max_active_levels = __kmp_dflt_max_active_levels;
-    hot_team -> t.t_sched.r_sched_type = r_sched.r_sched_type;
-    hot_team -> t.t_sched.chunk        = r_sched.chunk;
-#endif // OMP_30_ENABLED
+    hot_team->t.t_nproc = 1;
+    // TODO???: hot_team->t.t_max_active_levels = __kmp_dflt_max_active_levels;
+    hot_team->t.t_sched.r_sched_type = r_sched.r_sched_type;
+    hot_team->t.t_sched.chunk        = r_sched.chunk;
 #if KMP_MIC
-    hot_team -> t.t_size_changed = 0;
+    hot_team->t.t_size_changed = 0;
 #endif
 
 }
@@ -4041,7 +2928,7 @@
     }; // if
 }
 
-static void
+void
 __kmp_print_structure(
     void
 ) {
@@ -4185,10 +3072,10 @@
 unsigned short
 __kmp_get_random( kmp_info_t * thread )
 {
-  unsigned x = thread -> th.th_x;
+  unsigned x = thread->th.th_x;
   unsigned short r = x>>16;
 
-  thread -> th.th_x = x*thread->th.th_a+1;
+  thread->th.th_x = x*thread->th.th_a+1;
 
   KA_TRACE(30, ("__kmp_get_random: THREAD: %d, RETURN: %u\n",
          thread->th.th_info.ds.ds_tid, r) );
@@ -4203,9 +3090,9 @@
 {
   unsigned seed = thread->th.th_info.ds.ds_tid;
 
-  thread -> th.th_a = __kmp_primes[seed%(sizeof(__kmp_primes)/sizeof(__kmp_primes[0]))];
-  thread -> th.th_x = (seed+1)*thread->th.th_a+1;
-  KA_TRACE(30, ("__kmp_init_random: THREAD: %u; A: %u\n", seed, thread -> th.th_a) );
+  thread->th.th_a = __kmp_primes[seed%(sizeof(__kmp_primes)/sizeof(__kmp_primes[0]))];
+  thread->th.th_x = (seed+1)*thread->th.th_a+1;
+  KA_TRACE(30, ("__kmp_init_random: THREAD: %u; A: %u\n", seed, thread->th.th_a) );
 }
 
 
@@ -4430,7 +3317,8 @@
     /* find an available thread slot */
     /* Don't reassign the zero slot since we need that to only be used by initial
        thread */
-    for( gtid=(initial_thread ? 0 : 1) ; TCR_PTR(__kmp_threads[gtid]) != NULL ; gtid++ );
+    for( gtid=(initial_thread ? 0 : 1) ; TCR_PTR(__kmp_threads[gtid]) != NULL ; gtid++ )
+        ;
     KA_TRACE( 1, ("__kmp_register_root: found slot in threads array: T#%d\n", gtid ));
     KMP_ASSERT( gtid < __kmp_threads_capacity );
 
@@ -4475,69 +3363,61 @@
     __kmp_initialize_root( root );
 
     /* setup new root thread structure */
-    if( root -> r.r_uber_thread ) {
-        root_thread = root -> r.r_uber_thread;
+    if( root->r.r_uber_thread ) {
+        root_thread = root->r.r_uber_thread;
     } else {
         root_thread = (kmp_info_t*) __kmp_allocate( sizeof(kmp_info_t) );
         if ( __kmp_storage_map ) {
             __kmp_print_thread_storage_map( root_thread, gtid );
         }
-        root_thread -> th.th_info .ds.ds_gtid = gtid;
-        root_thread -> th.th_root =  root;
+        root_thread->th.th_info .ds.ds_gtid = gtid;
+        root_thread->th.th_root =  root;
         if( __kmp_env_consistency_check ) {
-            root_thread -> th.th_cons = __kmp_allocate_cons_stack( gtid );
+            root_thread->th.th_cons = __kmp_allocate_cons_stack( gtid );
         }
         #if USE_FAST_MEMORY
             __kmp_initialize_fast_memory( root_thread );
         #endif /* USE_FAST_MEMORY */
 
         #if KMP_USE_BGET
-            KMP_DEBUG_ASSERT( root_thread -> th.th_local.bget_data == NULL );
+            KMP_DEBUG_ASSERT( root_thread->th.th_local.bget_data == NULL );
             __kmp_initialize_bget( root_thread );
         #endif
         __kmp_init_random( root_thread );  // Initialize random number generator
     }
 
     /* setup the serial team held in reserve by the root thread */
-    if( ! root_thread -> th.th_serial_team ) {
-        #if OMP_30_ENABLED
-            kmp_internal_control_t r_icvs = __kmp_get_global_icvs();
-        #endif // OMP_30_ENABLED
+    if( ! root_thread->th.th_serial_team ) {
+        kmp_internal_control_t r_icvs = __kmp_get_global_icvs();
         KF_TRACE( 10, ( "__kmp_register_root: before serial_team\n" ) );
-        root_thread -> th.th_serial_team = __kmp_allocate_team( root, 1, 1,
+        root_thread->th.th_serial_team = __kmp_allocate_team( root, 1, 1,
 #if OMP_40_ENABLED
           proc_bind_default,
 #endif
-#if OMP_30_ENABLED
           &r_icvs,
-#else
-          __kmp_dflt_team_nth_ub,
-          __kmp_global.g.g_dynamic,
-          __kmp_dflt_nested,
-          __kmp_dflt_blocktime,
-          __kmp_bt_intervals,
-          __kmp_env_blocktime,
-#endif // OMP_30_ENABLED
-          0 );
+          0 USE_NESTED_HOT_ARG(NULL) );
     }
-    KMP_ASSERT( root_thread -> th.th_serial_team );
+    KMP_ASSERT( root_thread->th.th_serial_team );
     KF_TRACE( 10, ( "__kmp_register_root: after serial_team = %p\n",
-      root_thread -> th.th_serial_team ) );
+      root_thread->th.th_serial_team ) );
 
     /* drop root_thread into place */
     TCW_SYNC_PTR(__kmp_threads[gtid], root_thread);
 
-    root -> r.r_root_team -> t.t_threads[0] = root_thread;
-    root -> r.r_hot_team  -> t.t_threads[0] = root_thread;
-    root_thread -> th.th_serial_team -> t.t_threads[0] = root_thread;
-    root_thread -> th.th_serial_team -> t.t_serialized = 0; // AC: the team created in reserve, not for execution (it is unused for now).
-    root -> r.r_uber_thread = root_thread;
+    root->r.r_root_team->t.t_threads[0] = root_thread;
+    root->r.r_hot_team ->t.t_threads[0] = root_thread;
+    root_thread->th.th_serial_team->t.t_threads[0] = root_thread;
+    root_thread->th.th_serial_team->t.t_serialized = 0; // AC: the team created in reserve, not for execution (it is unused for now).
+    root->r.r_uber_thread = root_thread;
 
     /* initialize the thread, get it ready to go */
     __kmp_initialize_info( root_thread, root->r.r_root_team, 0, gtid );
 
     /* prepare the master thread for get_gtid() */
     __kmp_gtid_set_specific( gtid );
+
+    __kmp_itt_thread_name( gtid );
+
     #ifdef KMP_TDATA_GTID
         __kmp_gtid = gtid;
     #endif
@@ -4547,7 +3427,7 @@
 
     KA_TRACE( 20, ("__kmp_register_root: T#%d init T#%d(%d:%d) arrived: join=%u, plain=%u\n",
                     gtid, __kmp_gtid_from_tid( 0, root->r.r_hot_team ),
-                    root -> r.r_hot_team -> t.t_id, 0, KMP_INIT_BARRIER_STATE,
+                    root->r.r_hot_team->t.t_id, 0, KMP_INIT_BARRIER_STATE,
                     KMP_INIT_BARRIER_STATE ) );
     { // Initialize barrier data.
         int b;
@@ -4572,6 +3452,34 @@
     return gtid;
 }
 
+#if KMP_NESTED_HOT_TEAMS
+static int
+__kmp_free_hot_teams( kmp_root_t *root, kmp_info_t *thr, int level, const int max_level )
+{
+    int i, n, nth;
+    kmp_hot_team_ptr_t *hot_teams = thr->th.th_hot_teams;
+    if( !hot_teams || !hot_teams[level].hot_team ) {
+        return 0;
+    }
+    KMP_DEBUG_ASSERT( level < max_level );
+    kmp_team_t *team = hot_teams[level].hot_team;
+    nth = hot_teams[level].hot_team_nth;
+    n = nth - 1;                   // master is not freed
+    if( level < max_level - 1 ) {
+        for( i = 0; i < nth; ++i ) {
+            kmp_info_t *th = team->t.t_threads[i];
+            n += __kmp_free_hot_teams( root, th, level + 1, max_level );
+            if( i > 0 && th->th.th_hot_teams ) {
+                __kmp_free( th->th.th_hot_teams );
+                th->th.th_hot_teams = NULL;
+            }
+        }
+    }
+    __kmp_free_team( root, team, NULL );
+    return n;
+}
+#endif
+
 /* Resets a root thread and clear its root and hot teams.
    Returns the number of __kmp_threads entries directly and indirectly freed.
 */
@@ -4589,10 +3497,21 @@
     root->r.r_hot_team  = NULL;
         // __kmp_free_team() does not free hot teams, so we have to clear r_hot_team before call
         // to __kmp_free_team().
-    __kmp_free_team( root, root_team );
-    __kmp_free_team( root, hot_team );
+    __kmp_free_team( root, root_team USE_NESTED_HOT_ARG(NULL) );
+#if KMP_NESTED_HOT_TEAMS
+    if( __kmp_hot_teams_max_level > 1 ) {  // need to free nested hot teams and their threads if any
+        for( i = 0; i < hot_team->t.t_nproc; ++i ) {
+            kmp_info_t *th = hot_team->t.t_threads[i];
+            n += __kmp_free_hot_teams( root, th, 1, __kmp_hot_teams_max_level );
+            if( th->th.th_hot_teams ) {
+                __kmp_free( th->th.th_hot_teams );
+                th->th.th_hot_teams = NULL;
+            }
+        }
+    }
+#endif
+    __kmp_free_team( root, hot_team USE_NESTED_HOT_ARG(NULL) );
 
-#if OMP_30_ENABLED
     //
     // Before we can reap the thread, we need to make certain that all
     // other threads in the teams that had this root as ancestor have stopped trying to steal tasks.
@@ -4600,7 +3519,6 @@
     if ( __kmp_tasking_mode != tskm_immediate_exec ) {
         __kmp_wait_to_unref_task_teams();
     }
-#endif /* OMP_30_ENABLED */
 
     #if KMP_OS_WINDOWS
         /* Close Handle of root duplicated in __kmp_create_worker (tr #62919) */
@@ -4616,7 +3534,7 @@
         // We canot put root thread to __kmp_thread_pool, so we have to reap it istead of freeing.
     root->r.r_uber_thread = NULL;
     /* mark root as no longer in use */
-    root -> r.r_begin = FALSE;
+    root->r.r_begin = FALSE;
 
     return n;
 }
